#!/usr/bin/env python3.7
# -*- coding: utf-8 -*-
#Lanc dans autostart avec ShutD.sh
#Bouton appuy au moins 3 Secondes
#Ventilateur en PWM

import os
import time
import RPi.GPIO as GPIO
from threading import Thread

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
#GPIO-26 pour le Poussoir
SD=26
#on met le GPIO26 en Entre et  UP
GPIO.setup(SD, GPIO.IN, pull_up_down=GPIO.PUD_UP)
#Ventilateur sur GPIO18 en PWM  10 Hz
pwm=18
GPIO.setup(pwm,GPIO.OUT,initial=GPIO.LOW)
fan=GPIO.PWM(pwm,10)
#T1,V1,T2,V2,T3,V3
cnf=[50,70,53,80,58,100]
waitSD=3.0
waitFAN=30

def Shutdown():
	while True:
		GPIO.wait_for_edge(SD, GPIO.FALLING)
		debut=time.time()
		intS=0
		print ("SHUTDOWN dans 3 secondes")
		while intS < waitSD and GPIO.input(SD) == GPIO.LOW:
			intS=time.time()-debut
			time.sleep(0.5)
		if intS >= waitSD and GPIO.input(SD) == GPIO.LOW :
			GPIO.cleanup()
			os.system('sudo shutdown -h now')
			#print ("SHUT")

def Ventil():
	while True:
		temp = os.popen("vcgencmd measure_temp").readline()
		temp = temp.replace("temp=","")
		temp = int(float(temp.replace("'C","")))
		if temp < cnf[0]:
			fan.stop()
			#print (str(temp) + " V0")
		else:
			fan.start(0)
			if temp < cnf[2] and temp >= cnf[0]:
				fan.ChangeDutyCycle(cnf[1])
				time.sleep(0.01)
				#print (str(temp) + " V1")
			elif temp < cnf[4] and temp >= cnf[2]:
				fan.ChangeDutyCycle(cnf[3])
				time.sleep(0.01)
				#print (str(temp) + " V2")
			else:
				fan.ChangeDutyCycle(cnf[5])
				time.sleep(0.01)
				#print (str(temp) + " V3")
		time.sleep(waitFAN)

	fan.stop()
	GPIO.cleaup()

try:
	t1 = Thread(target = Shutdown)
	t2 = Thread(target = Ventil)
	t1.start()
	t2.start()
except:
	t1.stop()
	t2.stop()
	GPIO.cleanup()
